import 'dart:async';
import 'package:hooks_riverpod/hooks_riverpod.dart';
import 'chat_config_template.dart';

// final msgsProvider=StateNotifierProvider<msgsController,List<msg>?>((ref){
//   final cnl=ref.watch(selectedChannelPvd).state;
//   final offsetMsg=ref.read(msgOffsetPvd)[0];
//   if(offsetMsg==null) return msgsController(cnl,ref.read,[]);
//   else return msgsController(cnl,ref.read,[offsetMsg]);
// });

class msgsController<C,M> extends StateNotifier<List<M>?>{
  final Reader _read;
  final C? cnl;
  final tempConfig_Msg<C,M> config;
  late List<M> cache;
  late bool streamInCache;
  StreamSubscription<List<M>>? _msgSub;

  msgsController(this.cnl,this._read,this.cache,{required this.config}) : super(null) {
    streamInCache=false;
    _msgSub?.cancel();
    if(cnl!=null){
      if(cache.isEmpty)initStream();
      else loadOffset().then((v)=>initStream());
    }
  }

  void initStream(){
    assert(cnl!=null);
    _msgSub=config.stream
        .listen((event) {
          if(mounted) state=_precess(event);
      });
  }

  @override
  void dispose() {
    endStream();
    // TODO: implement dispose
    super.dispose();
  }

  void endStream(){
    _msgSub?.cancel();
  }

  List<M> _precess(List<M>stream){
    if(stream.isEmpty)return cache;
    stream.sort((a,b)=>config.getTime(b).compareTo(config.getTime(a)));
    if(cache.isEmpty){
      streamInCache=true;
      cache.addAll(stream);}
    // cache.sort((a,b)=>b.time.compareTo(a.time));
    ///if stream and cache overlaps
    if(config.getTime(stream.last).compareTo(config.getTime(cache.first))<=0){
      streamInCache=true;
      final List<M> added=[];
      for(int i=0;i<stream.length;i++){
        if(config.getId(stream[i])!=config.getId(cache[0])){
          added.insert(0, stream[i]);}
        else{ break;}
      }
      cache.insertAll(0, added);}
    ///if cache doesn't reach stream
    else{
      streamInCache=false;
    }
    return cache;
  }

  Future<void> loadB4() async{
    if(_read(config.loadingPvd)||cache.isEmpty)return;
    _read(config.loadingPvd.state).state=true;
    final pre=await config.loadb4(config.getTime(cache.last).toIso8601String(),cnl!);
    cache.addAll(pre);
    state=cache;
    _read(config.loadingPvd.state).state=false;
  }

  Future<void> loadAf() async{
    if(streamInCache)return;
    if(_read(config.loadingPvd)||cache.isEmpty)return;
    _read(config.loadingPvd.state).state=true;
    final post=await config.loadb4(config.getTime(cache.last).toIso8601String(),cnl!);
    if(post.length<10)streamInCache=true;
    cache.insertAll(0,post);
    state=cache;
    _read(config.loadingPvd.state).state=false;
  }

  Future<void> loadOffset()async{
    ///prevent setState while building message view
    Future.microtask(() => _read(config.loadingPvd.state).state=true);
    final pre=config.loadb4(config.getTime(cache.last).toIso8601String(),cnl!)
        .then((v){
          cache.addAll(v);
        });
    final post=config.loadb4(config.getTime(cache.last).toIso8601String(),cnl!)
        .then((v){
          if(v.length<10)streamInCache=true;
          cache.insertAll(0,v);});
    await Future.wait([pre,post]);
    state=cache;
    _read(config.loadingPvd.state).state=false;
  }
}