import 'package:algolia/algolia.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';
import 'package:pc_plugins/controllers/pageInfo_controller.dart';

import '../custom_exception.dart';
import 'algolia_filter_providers.dart';
import 'config_template.dart';

// final csProvider= StateNotifierProvider<tController,AsyncValue<List<Case>>>(
//         (ref){final user=ref.watch(authControllerProvider);
//     return csController(ref.read,user?.uid);
//     });

class tController<T> extends StateNotifier<AsyncValue<List<T>>> {
  final Reader reader;
  final String? uid;
  final repo_tempConfig<T> config;
  // String pageid;
  // int defaultPSize;

  tController(this.reader,this.uid,{required this.config}) :
        // pageid=cf.pageid,
        // defaultPSize=cf.defaultPSize,
        super(AsyncValue.loading());

  pageInd get searchConfig=>reader(pageIndexPvd(config.pageid));

  Future<void> initialLoad()async{
    if(state.asData==null)await load();
  }

  void setDialog(String s){
    if(config.dialogC!=null)
      reader(config.dialogC!.state).update((state) => s);
  }
  void setExDialog(CustomException e){
    if(config.exDialogC!=null)
      reader(config.exDialogC!.state).update((state) => e);
  }

  Future<void> load({int? lmt}) async{
    return search(null,lmt: lmt??config.defaultPSize);
  }

  Future<void> loadafter({int? lmt}) async{
    if(searchConfig.canNext)
      return search(searchConfig.query,page: searchConfig.page+1,
          lmt: lmt??config.defaultPSize);
    else setDialog("this is the last page :|");
  }

  Future<void> search(String? s,{int? lmt,int page=0}) async{
    if(reader(searchingPvd(config.pageid))||uid==null)return;

    if(config.onSearchChange!=null)config.onSearchChange!(reader);
    reader(searchingPvd(config.pageid).state).state=true;

    final filters=reader(algoFiltersPvd(config.pageid)).values.where((e) => e!=null)
        .cast<AlgoliaQuery Function(AlgoliaQuery)>().toList();
    final filterstr=reader(algoFiltersPvd_str(config.pageid)).values.where((e) => e!=null)
        .cast<String>().toList();

    try {
      final agdata=await reader(config.dataSrcPvd).searchTSnaps_algo(
          s, page: page, containID: uid,filters: filters, strFilters: filterstr);
      if(agdata.nbHits==0){
        setDialog("no result found");
      }

      reader(pageIndexPvd(config.pageid).state).state=pageInd.fromAlgo(agdata);
      final data=await reader(config.dataSrcPvd).snaps_2_Tdata(agdata.hits);
      state = AsyncValue.data(data);

    } on CustomException catch (e, st) {
      setExDialog(e);
    }
    reader(searchingPvd(config.pageid).state).state=false;
  }

  Future<void> getSuggest(T c) async{
    if(reader(searchingPvd(config.pageid))||uid==null)return;

    if(config.onSearchClick!=null)config.onSearchClick!(reader);
    reader(searchingPvd(config.pageid).state).state=true;
    try {
      // gcs = await reader(fsRepoProvider).getGCs(uid,lmt);
      final data=await reader(config.dataSrcPvd).getbyId(config.getId(c));
      state = AsyncValue.data([data]);

      reader(pageIndexPvd(config.pageid).state).state=pageInd(end: 1, total: 1);
    } on CustomException catch (e, st) {
      setExDialog(e);
    }
    reader(searchingPvd(config.pageid).state).state=false;
  }

  Future<void> loadb4({int? lmt}) async{
    if(searchConfig.canPre)
      return search(searchConfig.query,
          page: searchConfig.page-1,
          lmt: lmt??config.defaultPSize);
    else
      setDialog("this is the first page :|");
  }

  updatePvds(T c){
    final replace=state.asData!.value.indexWhere(
            (e) => config.getId(e)==config.getId(c));
    if(replace!=-1)
      state=state.whenData((value) => value..[replace]=c);
  }

  Future<bool> updateT(T c)async{
    try{
      reader(config.dataSrcPvd).edit(c);
      // reader(csSelectedPvd).state=c;
      updatePvds(c);
      return true;
    }on CustomException catch(e,st){
      setExDialog(e);
      return false;
    }
  }

  Future<bool> addT(T c)async{
    try{
      reader(config.dataSrcPvd).add(c);
      // reader(csSelectedPvd).state=c;

      final pageInfo=reader(pageIndexPvd(config.pageid));
      if(pageInfo.query==null
          &&pageInfo.end-pageInfo.start+1<config.defaultPSize)
      {state=state.whenData((v) => v..add(c));}
      return true;
    }on CustomException catch(e,st){
      setExDialog(e);
      return false;
    }
  }

  Future<void> set2read(T c)async{
    try{
      if(uid==null||config.isUnread==null||!config.isUnread!(c,uid!))return;
      final nw=await reader(config.dataSrcPvd).read(c,uid!);
      updatePvds(nw);
    }on CustomException catch(e,st){
      setExDialog(e);
    }
  }
}
