import 'package:algolia/algolia.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';

import '../custom_exception.dart';
import 'algolia_filter_providers.dart';
import 'config_template.dart';

final suggestionLoadingPvd=AutoDisposeStateProviderFamily<bool,String>((ref, roles) => false);

class suggestionsController_temp<T> extends StateNotifier<List<T>>{
  final Reader reader;
  final String? myId;
  final sug_tempConfig<T> config;
  String lastSearch="";

  suggestionsController_temp(this.reader,this.myId,{required this.config}) : super([]);

  void setDialog(String s){
    if(config.dialogC!=null)
      reader(config.dialogC!.state).update((state) => s);
  }
  void setExDialog(CustomException e){
    if(config.exDialogC!=null)
      reader(config.exDialogC!.state).update((state) => e);
  }

  Future<void> search(String q,{List<String>? more=const []})async{
    lastSearch=q;
    if(reader(suggestionLoadingPvd(config.pageid)))return;
    reader(suggestionLoadingPvd(config.pageid).state).state=true;

    if(q.isEmpty){
      state=[];
      reader(suggestionLoadingPvd(config.pageid).state).state=false;
      return;
    }

    final filters=reader(algoFiltersPvd(config.pageid)).values.where((e) => e!=null)
        .cast<AlgoliaQuery Function(AlgoliaQuery)>().toList();
    final filterstr=reader(algoFiltersPvd_str(config.pageid)).values.where((e) => e!=null)
        .cast<String>().toList();

    try{
      final snaps=await reader(config.dataSrcPvd).searchTSnaps_algo(q,containID: myId,
          filters: filters, strFilters: filterstr,
          attributes:config.attributesAlgo..addAll(more??[]));
      reader(suggestionLoadingPvd(config.pageid).state).state=false;

      if(q==lastSearch){
        state = snaps.hits.map((e) => config.getfromAlg(e)).toList();}
      else{ search(lastSearch);}
    }on CustomException catch(e,st){
      reader(suggestionLoadingPvd(config.pageid).state).state=false;
      setExDialog(e);
    }
  }

  void dismiss(){
    reader(suggestionLoadingPvd(config.pageid).state).state=false;
    state.clear();
  }
}