
import 'package:flutter/material.dart';

import 'colors.dart';
import 'formate.dart';
import 'others.dart';

TextStyle field_ts=TextStyle(fontSize: 16,fontWeight: FontWeight.w300,fontFamily: text_family,color: textColor,wordSpacing: 0);
TextStyle label_ts=TextStyle(fontSize: 12.5,fontWeight: FontWeight.w400,fontFamily: text_family,color: textColor,wordSpacing: 0);

toDatetime(dynamic d){
  return d==null?null:
  (d is DateTime)?d:d.toDate();
}

const EdgeInsets field_padding=EdgeInsets.fromLTRB(16,4,16,0);
const double field_height=75;
const double field_height_thick=160;
const int maxLength=99;


const f="f";
const n="n";

const List<String> marriSt = ["Single","Married","In a relationship"];


const diseases=["TB/exposed to TB","Cancer","Irregular Heartbeat","Heart problems / congenital heart defect","Head injuries","Thyroid Problems",
  "Seizures","Anemia","Genital Warts","Chlamydia","Gonorrhea","Genital Herpes","Syphilis","HIV","Hepatitis B","Hepatitis C","Ovarian Cysts","HPV"];

const ipTransmittedDiseases=['Hepatitis B Positive','Hepatitis B Exposed','Hepatitis A','Hepatitis C','HIV Positive','Syphilis','Chlamydia','CMV'];


const Color filledC=Color(0xFFF5F5F5);


InputDecoration formdec(String? label,String? hint,{bool labelFloat=false,bool thick=false,Widget? prefix})=>InputDecoration(
    border: InputBorder.none,
    focusedBorder: UnderlineInputBorder(),
    contentPadding: EdgeInsets.fromLTRB(12, 6, 12, 2),
    labelText: label==null||thick||label.length>maxLength?null:label,
    labelStyle:label_ts,fillColor: filledC,filled: true,
    hintText: hint,prefixIcon: prefix,
    floatingLabelBehavior: labelFloat?FloatingLabelBehavior.always:FloatingLabelBehavior.auto
);

const InputDecoration prfDec=InputDecoration(
  border: OutlineInputBorder(),
  focusedBorder: UnderlineInputBorder(),
  contentPadding: EdgeInsets.fromLTRB(12, 6, 12, 2),
  fillColor: filledC,filled: true,
);

InputDecoration prfDec_label(String label,{bool isDD=false,Widget? icon,String? hint})=>InputDecoration(
  labelText: label,labelStyle: label_ts,
  floatingLabelBehavior:FloatingLabelBehavior.always,
  border: OutlineInputBorder(),
  prefixIcon: icon,hintText: hint,
  focusedBorder: UnderlineInputBorder(),
  contentPadding: isDD?EdgeInsets.fromLTRB(12, 6, 12, 12):EdgeInsets.fromLTRB(12, 16, 12, 12),
  fillColor: filledC,filled: true,
);

String? phoneValidator(String? pn,{String invalid="invalid number!",bool cn=false,bool us=true}){
  if(pn==null)return invalid;
  final ppn=unformatPhone(pn,trim1: false);
  if(ppn.startsWith("1")){
    if((cn||us)&&ppn.length==11)return null;}
  else if(us&&ppn.length==10) return null;
  return invalid;
}

String? pwValidator(String? pw,{bool required=true,
  String invalid="invalid password!",}){
  if(pw==null||pw.isEmpty)return required?invalid:null;

  if(pw.length<8)return invalid;
  return null;
}
